//alcune di queste def sono in comune con Connectivity.h si potrebbero mettere insieme!

#define ERRORTIME 100000
#define NMAX 50
#define LIGHTSPEED 3E8
#define delta 0.5
#define pi 3.14
#define INFINITY 1000000	//infinito
#define TXmsg	1		//costante consumo di potenza tx messaggio
#define MAXPDU 1
#define LE 1
#define LC 2
#define DATA 6
#define NACK 99
#define RETRANSMIT 98
#define GENERATRAFFICO 7
#define GENERAMOBUPDATE 8
#define AGGIORNASTA 16
#define FINE 17
#define PACKETCHECK 18
#define PACKETSTATUS 22
#define ACKDATA 23
#define SENDPACKET 24
#define missingACKDATA 25
#define MISSINGDATA 26
#define REFRESHLIST 27
#define DISTANCE_REQUEST 28
#define DISTANCE_REPLY 29
#define REFRESHINGINTERVAL 5
#define STATINTERVAL 5

//Tipi di richieste e costanti relative al traffico

#define MAXDIMBIT	1E9
#define MAXDATASIZE	1288
#define HTTP 1
#define FTP 2
#define ACKDATASIZE 51 //Coded size at the PHY, for simplicity 
#define LESIZE 51 //Coded size at the PHY, for simplicity 
#define LCSIZE 51 //Coded size ar the PHY, for simplicity
#define PHYHeaderSize 64
#define processingBitTime 1E-9
#define DISTANCE_TIMEOUT 2
#define LASTPACKET_TIMEOUT 5E-2
#define TIMEOUTActive 100000
#define TIMEOUTLC 100000
#define TIMEOUTDATA 100000
#define PULSELENGTH 1E-9
#define TRANSMITTER_RESET_TIME 0 //Keep this value coherent with FPL.cc! 
#define FEC_LIMIT 0

double RETRANSMIT_RATE_STEP;
struct posizione
{
	double x;
	double y;
	double NodeEnergy;
};

struct NeighbourRecord
{
	double distance;
	bool distanceValidity;
	double time;
	double distanceEstimationTime;
	double lastPacketTime;
	int receivedPacketsMemory;
};

extern bool networkconnectivity[NMAX][NMAX];
extern bool visibilityMatrix[NMAX][NMAX];
extern double generatedMUI[NMAX][NMAX];

extern int pacchettiDATAinviati[NMAX];
extern int pacchettiDATAricevuti[NMAX];
extern int pacchettiDATAmissedSync[NMAX];
extern int pacchettiDATALost[NMAX];
extern int pacchettiDATAcollided[NMAX];
extern int pacchettiDATADropped[NMAX];

extern int pacchettiACKDATAinviati[NMAX];
extern int pacchettiACKDATAricevuti[NMAX];
extern int pacchettiACKDATAmissedSync[NMAX];

extern int pacchettiLEinviati[NMAX];
extern int pacchettiLEricevuti[NMAX];
extern int pacchettiLEmissedSync[NMAX];

extern int pacchettiLCinviati[NMAX];
extern int pacchettiLCricevuti[NMAX];
extern int pacchettiLCmissedSync[NMAX];
extern double PEP[NMAX];
extern double BEP[NMAX];
extern double AveragePacketCollisions[NMAX];
extern double NbInterferenti[NMAX];
extern double NodesResidualEnergyVector[NMAX];
extern int TotPktEnergyCntVector[NMAX];
extern double averagedelay[NMAX];
extern struct posizione database[NMAX];
extern struct NeighbourRecord NeighbourMatrix[NMAX][NMAX];
extern double delayrtt[NMAX][2];
extern double endTransmission[NMAX];
extern double transmittedPower[NMAX];
extern double RMS_Matrix[NMAX][NMAX];
extern double PEAK_Matrix[NMAX][NMAX];
extern FPL *packList;
double sogliaSNR;		//15.85
double noisePower;		//1.99E-12
						//double Ptx = 1.448313e-05; /* W */ //LOS, 50*1.41442 m
double Ptx;// = 2.135442e-01; /* W */ //NLOS, 50*1.41442 m
double noiseDensity;
double Ts;
double Tm;
double Ns;
double STDPOWER;
double MUI_margin;
double PCMUIModel;
double PACKETRATE;			//1000000
bool DEBUG;
bool PC_ENHANCED;			//pulse collision mode enabled
bool SlottedAloha;
bool IEEE_802_15_4_a;
double NarrowBandInterf;
//Channel path loss settings
double average_pathlossExp_;
double pathlossExp_stdev_;
double averageShadow_dev;
double Shadow_dev_stdev;
double lambda;
double dist0_;
double PL0_802_15_4a[5] = {0, 43.9, 48.7, 43.29, 43.29};
double pathloss_exp_802_15_4a[5] = {0, 1.79, 4.58, 1.76,2.5};
double shadow_stdv_802_15_4a[5]={0, 2.22, 3.51, 0.83, 2};
double shadow_term_802_15_4a;
int scenario;

//variables used for the packet consumed energy
bool SendingPacketFlag; //this is used as imput of the packet energy evaluation, that is the function use to evaluate the cost of transmitting and receiving pkts 
double InitialNodeEnergy;
double NodeResidualEnergy[NMAX];
int NodePktEnergyCnt[NMAX];

//Optical variables
bool DWO_OOC;
bool optics;
double FreqLED;
int OocLenght,OocWeight;
double Eta, CeilingHeight, OocRecThreshold;




